/*********************************************************************
 *
 *  Wattmon
 *    
 *  File : EZDisplay.js
 * 
 *  Description: EZ Display Controller
 *
 *********************************************************************
 * Company:         Cynergy Software
 *
 * Software License Agreement
 *
 * Copyright (c) 2013-2018 Cynergy Software.  All rights reserved.
 *
 * Cynergy licenses to you the right to use, modify, copy, and 
 * distribute: 
 * (i)  the Software when used on a Wattmon device
 * (ii) the Software on any platform or device for personal use
 *
 * For commercial use please contact us via http://www.wattmon.com
 *
 * THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT 
 * WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT 
 * LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT SHALL 
 * CYNERGY BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF 
 * PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS 
 * BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE 
 * THEREOF), ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER 
 * SIMILAR COSTS, WHETHER ASSERTED ON THE BASIS OF CONTRACT, TORT 
 * (INCLUDING NEGLIGENCE), BREACH OF WARRANTY, OR OTHERWISE.
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Akash Heimlich                   v1.0
 * Latest revision: 	11/09/18
 ********************************************************************/

function EZDisplayCtrl($scope,$http) {
const TYPE_GENSET=1;
const TYPE_GRID=2;
const TYPE_SOLAR_METER=3;
const TYPE_LOAD=4;
const FONT_SIZE=18;
init_scope($scope);





bar_color="#808080";
text_color="#000";
background_color="#FFF";
label_color="#6bae3f";
num_matrix_rows=1;
num_matrix_cols=5;

matrix_width=100;
matrix_height=100;
items_left=[];      // grid stuff
items_top=[];       // solar stuff
items_right=[];     // load stuff
items_bottom=[];    // DG stuff
max_items_x=0;
max_items_y=0;
/*
* Possible lines:
* vertical_line, horizontal_line, horizontal_split_bottom, horizontal_split_top, vertical_split_bottom, vertical_split_top
*/


if (hasSolarMeter) {
    item={
            //count:pm.length,
            top:'horizontal_split_top',
            bottom:'horizontal_split_bottom',
            margin:5,
            height:matrix_height,
            items:[]
        };
        
    for (i=0; i < pm.length; i++) {
        if (pm[i].type==TYPE_SOLAR_METER) {
            item.items.push({
                    image:'/img/energymeter.png',
                    dynamic:true,
                    type:'meter',
                    index:i,
                    height:matrix_height,
                    width:matrix_width
                });
        }
    }
    item.count=item.items.length;
    if (item.count>max_items_x) 
        max_items_x=item.count;
    items_top.push(item);
}

if (hasSolar) {
    item={
            count:hasSolar,
            top:'horizontal_split_top',
            bottom:'horizontal_split_bottom',
            margin:5,
            height:matrix_height,
            items:[]
            };      
            
    for (i=0;i<hasSolar;i++) {
        item.items.push({
                    image:urlPrefix+'/img/inverter.png',
                    caption:"",
                    dynamic:1,
                    type:'inverter',
                    index:i,
                    height:matrix_height,
                    width:matrix_width
                }
            );

    }
    if (item.items.length>max_items_x) 
        max_items_x=item.items.length;
    
    items_top.push(item);
    items_top.push({
            count:1,
            bottom:'vertical_line',
            margin:5,
            height:matrix_height,
            
            items:[
                {
                    image:urlPrefix+'/img/solar.svg',
                    label_right:"Solar",
                    height:matrix_height,
                    width:matrix_width
                }
            ]
            });
            
}


if (hasGrid) {
    // add the grid meters
    item={
            
            left:'vertical_split_left',
            right:'vertical_split_right',
            margin:5,
            height:matrix_height,
            
            items:[]
            };      

    for (i=0; i < pm.length; i++) {
        if (pm[i].type==TYPE_GRID) {
            item.items.push({
                    image:urlPrefix+'/img/energymeter.png',
                    caption:"",
                    dynamic:true,
                    type:'meter',
                    index:i,
                    height:matrix_height,
                    width:matrix_width
                });
        }
    } 
    item.count=item.items.length;
    if (item.items.length>max_items_y) 
        max_items_y=item.items.length;
    
    items_left.push(item);
    // add the grid icon
       
}

items_left.push({
            count:1,
            right:'horizontal_line',
            margin:5,
            items:[
                {
                    image:urlPrefix+'/img/grid.svg',
                    label_bottom:"Grid",
                    height:matrix_height,
                    width:matrix_width,
                }
            ]
            });
    

if (hasLoad) {
    // add the grid meters
    item={
            count:hasLoad,
            left:'vertical_split_left',
            right:'vertical_split_right',
            margin:5,
            height:matrix_height,
            
            items:[]
            };      

    for (i=0; i < pm.length; i++) {
        if (pm[i].type==TYPE_LOAD) {
            item.items.push({
                    image:urlPrefix+'/img/energymeter.png',
                    caption:"",
                    dynamic:true,
                    type:'meter',
                    index:i,
                    height:matrix_height,
                    width:matrix_width
                });
        }
    }            
    if (item.items.length>max_items_y) 
        max_items_y=item.items.length;
    items_right.push(item);
    // add the grid icon
    
    
}

items_right.push({
            count:1,
            left:"horizontal_line",
            margin:5,
            items:[
                {
                    image:urlPrefix+'/img/load.svg',
                    label_bottom:"Load",
                    height:matrix_height,
                    width:matrix_width,
                }
            ]
            });

if (hasGenset) {
    item={
            
            top:'horizontal_split_top',
            bottom:'vertical_lines',
            margin:5,
            height:matrix_height,
            items:[]
        };
        
    for (i=0; i < pm.length; i++) {
        if (pm[i].type==TYPE_GENSET) {
            item.items.push({
                    image:urlPrefix+'/img/energymeter.png',
                    caption:"",
                    dynamic:true,
                    type:'meter',
                    index:i,
                    height:matrix_height,
                    width:matrix_width 
                });
        }
    }
    item.count=item.items.length;
    items_bottom.push(item);
    item={
            //count:1,
            top:'vertical_lines',
            margin:5,
            height:matrix_height,
            items:[]
        };
        
    for (i=0; i < pm.length; i++) {
        if (pm[i].type==TYPE_GENSET) {
            item.items.push({
                    image:urlPrefix+'/img/genset.svg',
                    label_bottom:"Genset",
                    height:matrix_height,
                    width:matrix_width
                });
        };
    }
    item.count=item.items.length;
    items_bottom.push(item);
}


/**
 * Draw an arrowhead on a line on an HTML5 canvas.
 *
 * Based almost entirely off of http://stackoverflow.com/a/36805543/281460 with some modifications
 * for readability and ease of use.
 *
 * @param context The drawing context on which to put the arrowhead.
 * @param from A point, specified as an object with 'x' and 'y' properties, where the arrow starts
 *             (not the arrowhead, the arrow itself).
 * @param to   A point, specified as an object with 'x' and 'y' properties, where the arrow ends
 *             (not the arrowhead, the arrow itself).
 * @param radius The radius of the arrowhead. This controls how "thick" the arrowhead looks.
 */
function drawArrowhead(context, from, to, radius) {
	var x_center = to.x;
	var y_center = to.y;

	var angle;
	var x;
	var y;

	context.beginPath();

	angle = Math.atan2(to.y - from.y, to.x - from.x)
	x = radius * Math.cos(angle) + x_center;
	y = radius * Math.sin(angle) + y_center;

	context.moveTo(x, y);

	angle += (1.0/3.0) * (2 * Math.PI)
	x = radius * Math.cos(angle) + x_center;
	y = radius * Math.sin(angle) + y_center;

	context.lineTo(x, y);

	angle += (1.0/3.0) * (2 * Math.PI)
	x = radius *Math.cos(angle) + x_center;
	y = radius *Math.sin(angle) + y_center;

	context.lineTo(x, y);

	context.closePath();

	context.fill();
}

function drawLine(ctx, color, line_type, num_items, x, y, w, h) {
    ctx.beginPath();

    ctx.lineWidth=2;
    ctx.strokeStyle=color;

    if (line_type=='horizontal_line') {
        ctx.moveTo(x,y+h/2);
        ctx.lineTo(x+w,y+h/2);
        ctx.stroke();

    }

    if (line_type=='horizontal_lines') {
        item_height=h/num_items;
        console.log("item height="+item_height);
        for (i=0;i<num_items;i++) {

            ctx.moveTo(x,y+item_height*i+item_height/2);
            ctx.lineTo(x+w,y+item_height*i+item_height/2);
            ctx.stroke();
        }

    }
    
    if (line_type=='vertical_line') {
        ctx.moveTo(x+w/2,y);
        ctx.lineTo(x+w/2,y+h);
        ctx.stroke();

    }
    
    if (line_type=='vertical_lines') {
        item_width=w/num_items;
        console.log("item width="+item_width);
        for (i=0;i<num_items;i++) {
            ctx.moveTo(x+item_width*i+item_width/2,y);
            ctx.lineTo(x+item_width*i+item_width/2,y+h);
            ctx.stroke();
        }
    }
    
    if (line_type=='horizontal_split_top') {
    
        item_width=w/num_items;
        console.log("item width="+item_width);
        ctx.moveTo(x+w/2,y);
        ctx.lineTo(x+w/2,y+h/3);
        ctx.stroke();
        
        ctx.moveTo(x+item_width/2,y+h/3);        
        ctx.lineTo(x+w-item_width/2,y+h/3);
        ctx.stroke();
        
        for (i=0;i<num_items;i++) {
            ctx.moveTo(x+item_width*i+item_width/2,y+h/3);
            ctx.lineTo(x+item_width*i+item_width/2,y+h);
            ctx.stroke();
        }
    }
    
    if (line_type=='horizontal_split_bottom') {
        item_width=w/num_items;
        console.log("item width="+item_width);
        ctx.moveTo(x+item_width/2,y+h*2/3);
        ctx.lineTo(x+w-item_width/2,y+h*2/3);
        ctx.stroke();
    
        
        for (i=0;i<num_items;i++) {
            ctx.moveTo(x+item_width*i+item_width/2,y);
            ctx.lineTo(x+item_width*i+item_width/2,y+h*2/3);
            ctx.stroke();
        }
        ctx.moveTo(x+w/2,y+h*2/3);
        ctx.lineTo(x+w/2,y+h);
        ctx.stroke();
    }
    
    if (line_type=='vertical_split_left') {
        item_height=h/num_items;
        console.log("item height="+item_height);
        ctx.moveTo(x,y+h/2);
        ctx.lineTo(x+w/3,y+h/2);
        ctx.stroke();
        
        ctx.moveTo(x+w/3,y+item_height/2);
        ctx.lineTo(x+w/3,y+h-item_height/2);
        ctx.stroke();
        for (i=0;i<num_items;i++) {

            ctx.moveTo(x+w/3,y+item_height*i+item_height/2);
            ctx.lineTo(x+w,y+item_height*i+item_height/2);
            ctx.stroke();
        }

    }
    if (line_type=='vertical_split_right') {
        item_height=h/num_items;
        console.log("item height="+item_height);
        ctx.moveTo(x+w*2/3,y+item_height/2);
        ctx.lineTo(x+w*2/3,y+h-item_height/2);
        ctx.stroke();
        for (i=0;i<num_items;i++) {

            ctx.moveTo(x,y+item_height*i+item_height/2);
            ctx.lineTo(x+w*2/3,y+item_height*i+item_height/2);
            ctx.stroke();
        }
        ctx.moveTo(x+w*2/3,y+h/2);
        ctx.lineTo(x+w,y+h/2);
        ctx.stroke();
    }
    //ctx.endPath();
    
}

links=[];
var canvas = document.getElementById('ezcanvas');
fitToContainer(canvas);

function fitToContainer(canvas) {
  // Make it visually fill the positioned parent
  canvas.style.width ='100%';
  canvas.style.height='100%';
  // ...then set the internal size to match
  canvas.width  = canvas.offsetWidth;
  canvas.height = canvas.offsetHeight;
}

const getContext = () => document.getElementById('ezcanvas').getContext('2d');

canvasWidth=document.getElementById('ezcanvas').width;
canvasHeight=document.getElementById('ezcanvas').height;

// calculate the total number of 'blocks' vertically
gridSizeY = items_top.length + items_bottom.length+2;
if (!items_top.length && !items_bottom.length) gridSizeY=3;

gridSizeX = items_left.length + items_right.length;
ctx = canvas.getContext('2d')
ctx.font = FONT_SIZE+'px sans-serif';
lineHeight=ctx.measureText('M').width+2;
lineWidth=ctx.measureText('88.8kW').width+5;
gridWidth=canvasWidth/gridSizeX;
gridHeight=(canvasHeight-20)/gridSizeY;

if (gridWidth*max_items_x > canvasWidth) gridWidth=canvasWidth / (max_items_x+1);
if (gridHeight*max_items_y > canvasHeight) gridHeight=canvasHeight / (max_items_y+1);
if (gridWidth > gridHeight) {
    gridWidth=gridHeight;
} else gridHeight=gridWidth;
//if (gridHeight<100) 
 //gridHeight=100;

if (lineHeight>12) 
    gridHeight+=10+lineHeight-12;  // adjust for larger fonts
centerX=canvasWidth/2 - gridWidth/2;//-(gridWidth*items_left.length)/2;
centerY=gridHeight*items_top.length;
if (!centerY) centerY=canvasHeight/2 - gridHeight/2;


// It's better to use async image loading.
const loadImage = url => {
  return new Promise((resolve, reject) => {
    const img = new Image();
    img.onload = () => resolve(img);
    img.onerror = () => reject(new Error(`load ${url} fail`));
    img.src = url;
  });
};

// Here, I created a function to draw image.
const depict = options => {
  const ctx = getContext();
  // And this is the key to this solution
  // Always remember to make a copy of original object, then it just works :)
  const myOptions = Object.assign({}, options);
  return loadImage(myOptions.uri).then(img => {
    ctx.drawImage(img, myOptions.x, myOptions.y, myOptions.sw, myOptions.sh);
  });
};

const imgs = [];
var canvas = document.getElementById('ezcanvas');
ctx = canvas.getContext('2d');
//myctx.save();
ctx.save()

function drawGrid(ctx) {
    ctx.beginPath();
    
    ctx.lineWidth=0.5;
    ctx.strokeStyle="#c0c0c0";
    offsetX=centerX-items_left.length*gridWidth;
    offsetY=centerY-items_top.length*gridHeight;
    for (i=0;i<=gridSizeX;i++) {
        ctx.moveTo(i*gridWidth+offsetX,0);
        ctx.lineTo(i*gridWidth+offsetX,canvasHeight);
        ctx.stroke();    
    }
    
    for (i=0;i<=gridSizeY;i++) {
        ctx.moveTo(0,i*gridHeight+offsetY);
        ctx.lineTo(canvasWidth,i*gridHeight+offsetY);
        ctx.stroke();    
    }
    //ctx.endPath();

}

//drawGrid(ctx);
 
function progressBar(context,x,y,size,percent,percent_now,percent_potential){
    diff=(percent/100)*Math.PI*2;
    diff2=(percent_now/100)*Math.PI*2;
    diff3=(percent_potential/100)*Math.PI*2;
    
    start=0;
    cw=x+size/2;
    ch=y+size/2;
    context.clearRect(x-size/2,y-size/2,size*2,size*2);
    context.beginPath();
    context.lineWidth=size*0.8;
    context.strokeStyle='#eeeeee';
    context.arc(cw,ch,size/2,0,2*Math.PI,false);
    context.fillStyle='#eeeeee';
    context.fill();
    if (percent_potential>percent) {
        // potential generation
        context.lineWidth=size*0.8;
        context.strokeStyle='#b3cccc';//#b3cf3c';
        context.beginPath();
        context.arc(cw,ch,size/2,start,diff3+start,false);
        context.stroke();
    }
    context.strokeStyle='#e7f2ba';
    context.stroke();
    context.fillStyle='#000';
    context.strokeStyle='#ffad99';//#b3cf3c';
    context.textAlign='center';
    context.lineWidth=size*0.8;
    //context.font = '10pt Verdana';
    context.beginPath();
    context.arc(cw,ch,size/2,start,diff+start,false);
    context.stroke();
    
    
    //context.fillText(percent+'%',cw+2,ch+6);
    
    context.beginPath();
    context.lineWidth=size*0.4;
    context.arc(cw,ch,size/2,0,2*Math.PI,false);
    context.fillStyle='#FFFFFF';
    context.fill();
    context.strokeStyle='#e7f2ba';
//    context.stroke();
    context.fillStyle='#000';
    /*if (percent-percent_now>2) 
        context.strokeStyle='#ff9900';
    else*/
        context.strokeStyle='#009900';//#b3cf3c';
    context.textAlign='center';
    context.lineWidth=size*0.4;
    //context.font = '10pt Verdana';
    context.beginPath();
    context.arc(cw,ch,size/2,start,diff2+start,false);
    context.stroke();
    context.fillStyle='#000000';
    context.textBaseline = 'top';
    context.font = '10px Roboto, Helvetica, Arial';
   // context.fillText(percent_now+"%",cw, ch-5);
}
function drawCanvas(ctx) {

    if (hasIrradiation)
        imgs.push({ uri: "/img/sun.png", x: canvasWidth-gridWidth, y:  0, sw: gridWidth*0.56, sh: gridWidth*0.56 });
    if (hasWindSpeed)
        imgs.push({ uri: "/img/wind.png", x: canvasWidth-gridWidth*2, y:  0, sw: gridWidth*0.56, sh: gridWidth*0.56 });
        
    if (items_top.length)
        drawLine(ctx,bar_color,"vertical_line",1,centerX,centerY,gridWidth,gridHeight/2); // top quadrant
    if (items_bottom.length)
        drawLine(ctx,bar_color,"vertical_line",1,centerX,centerY+gridHeight/2,gridWidth,gridHeight/2); // top quadrant
    if (items_left.length)        
        drawLine(ctx,bar_color,"horizontal_line",1,centerX,centerY,gridWidth/2,gridHeight); // top quadrant
    if (items_right.length)        
        drawLine(ctx,bar_color,"horizontal_line",1,centerX+gridWidth/2,centerY,gridWidth/2,gridHeight); // top quadrant        
    
    cur_y=centerY;
    console.log("Cur_Y="+cur_y);
    var i;
    for (i=0;i<items_top.length;i++) {
        console.log("Item "+i);
        cur_x=centerX+gridWidth/2;
        console.log("Cur_X="+cur_x);
        cur_y-=gridHeight;
        console.log("Cur_Y="+cur_y);
        item = items_top[i];
        cur_width=item.count*gridWidth;
        cur_x-=cur_width/2;
        console.log("Width is "+cur_width);
        drawLine(ctx,bar_color,item.top,item.count,cur_x,cur_y,cur_width,gridHeight*0.22); // top quadrant
        drawLine(ctx,bar_color,item.bottom,item.count,cur_x,cur_y+gridWidth*0.8,cur_width,gridHeight-gridWidth*0.8); // top quadrant
        for (j=0;j<item.items.length;j++) {
             
             imgs.push({ uri: item.items[j].image, x: cur_x+(gridWidth*0.22), y:  cur_y+(gridHeight*0.22), sw: gridWidth*0.56, sh: gridWidth*0.56 });
             
             item.items[j].x=cur_x+(gridWidth*0.22);
             item.items[j].w=gridWidth*0.56;
             item.items[j].h=gridWidth*0.56;
             item.items[j].y=cur_y+(gridHeight*0.22);
             if (item.items[j].label_right) {
                ctx.fillStyle=label_color;
                ctx.textBaseline = 'top';
                
                ctx.font = '16px Roboto, Helvetica, Arial';
                ctx.fillText(item.items[j].label_right, item.items[j].x+item.items[j].w*1.1, item.items[j].y+ item.items[j].h*0.5);
             }
             cur_x+=gridWidth;
        }
    }
    cur_y=centerY;
    cur_x=centerX;
    var i;
    for (i=0;i<items_bottom.length;i++) {
    cur_y+=gridHeight;
        console.log("Item "+i);
        cur_x=centerX+gridWidth/2;
        console.log("Cur_X="+cur_x);
        
        console.log("Cur_Y="+cur_y);
        item = items_bottom[i];
        cur_width=item.count*gridWidth;
        cur_x-=cur_width/2;
        console.log("Width is "+cur_width);
        drawLine(ctx,bar_color,item.top,item.count,cur_x,cur_y,cur_width,gridHeight*0.22); // top quadrant
        drawLine(ctx,bar_color,item.bottom,item.count,cur_x,cur_y+gridHeight*0.78,cur_width,gridHeight*0.22); // top quadrant
        for (j=0;j<item.items.length;j++) {
             
             imgs.push({ uri: item.items[j].image, x: cur_x+(gridWidth*0.22), y:  cur_y+(gridHeight*0.22), sw: gridWidth*0.56, sh: gridHeight*0.56 });
             
             item.items[j].x=cur_x+(gridWidth*0.22);
             item.items[j].w=gridWidth*0.56;
             item.items[j].h=gridHeight*0.56;
             item.items[j].y=cur_y+(gridHeight*0.22);
             if (item.items[j].label_bottom) {
                ctx.fillStyle=label_color;
                ctx.textBaseline = 'top';
                ctx.font = '16px Roboto, Helvetica, Arial';
                ctx.fillText(item.items[j].label_bottom, item.items[j].x+item.items[j].w*0.5-ctx.measureText(item.items[j].label_bottom).width/2, item.items[j].y+ item.items[j].h*1.05);
             }
             cur_x+=gridWidth;
        }
        
    }
    cur_y=centerY;
    cur_x=centerX;
    for (i=0;i<items_left.length;i++) {
        console.log("Item "+i);
        cur_y=centerY+gridHeight/2;
        console.log("Cur_X="+cur_x);
        cur_x-=gridWidth;
        console.log("Cur_Y="+cur_y);
        item = items_left[i];
        cur_height=item.count*gridHeight;
        cur_width=gridWidth;
        cur_y-=cur_height/2;
        console.log("Width is "+cur_width);
        drawLine(ctx,bar_color,item.left,item.count,cur_x,cur_y,gridWidth*0.22,cur_height); // top quadrant
        drawLine(ctx,bar_color,item.right,item.count,cur_x+gridWidth*0.78,cur_y,gridWidth*0.22,cur_height); // top quadrant
        for (j=0;j<item.items.length;j++) {
             
             imgs.push({ uri: item.items[j].image, x: cur_x+(gridWidth*0.22), y:  cur_y+(gridHeight*0.22), sw: gridWidth*0.56, sh: gridHeight*0.56 });
             item.items[j].x=cur_x+(gridWidth*0.22);
             item.items[j].y=cur_y+(gridHeight*0.22);
             item.items[j].w=gridWidth*0.56;
             item.items[j].h=gridHeight*0.56;
             if (item.items[j].label_bottom) {
                ctx.fillStyle=label_color;
                ctx.textBaseline = 'top';
                ctx.font = '16px Roboto, Helvetica, Arial';
                ctx.fillText(item.items[j].label_bottom, item.items[j].x+item.items[j].w*0.5-ctx.measureText(item.items[j].label_bottom).width/2, item.items[j].y+ item.items[j].h*1.05);
             }
             cur_y+=gridHeight;
        }
    }
    cur_y=centerY;
    cur_x=centerX;
    for (i=0;i<items_right.length;i++) {
        console.log("Item "+i);
        cur_y=centerY+gridHeight/2;
        console.log("Cur_X="+cur_x);
        cur_x+=gridWidth;
        console.log("Cur_Y="+cur_y);
        item = items_right[i];
        cur_height=item.count*gridHeight;
        cur_width=gridWidth;
        cur_y-=cur_height/2;
        console.log("Width is "+cur_width);
        drawLine(ctx,bar_color,item.left,item.count,cur_x,cur_y,gridWidth*0.22,cur_height); // top quadrant
        drawLine(ctx,bar_color,item.right,item.count,cur_x+gridWidth*0.78,cur_y,gridWidth*0.22,cur_height); // top quadrant
        for (j=0;j<item.items.length;j++) {
             
             imgs.push({ uri: item.items[j].image, x: cur_x+(gridWidth*0.22), y:  cur_y+(gridHeight*0.22), sw: gridWidth*0.56, sh: gridHeight*0.56 });
             item.items[j].x=cur_x+(gridWidth*0.22);
             item.items[j].y=cur_y+(gridHeight*0.22);
             item.items[j].w=gridWidth*0.56;
             item.items[j].h=gridHeight*0.56;
             if (item.items[j].label_bottom) {
                ctx.fillStyle=label_color;
                ctx.textBaseline = 'top';
                ctx.font = '16px Roboto, Helvetica, Arial';
                ctx.fillText(item.items[j].label_bottom, item.items[j].x+item.items[j].w*0.5-ctx.measureText(item.items[j].label_bottom).width/2, item.items[j].y+ item.items[j].h*1.05);
             }
             cur_y+=gridHeight;
        }
    }
}
drawCanvas(ctx);

ctx.restore();

imgs.forEach(depict);

var hover = false, id;
var _i, _b;

// Render everything
//renderMap();
canvas.onmousemove = function(e) {
    e.preventDefault();
    e.stopPropagation();
    // Get the current mouse position
    var r = canvas.getBoundingClientRect(),
        x = e.clientX - r.left, y = e.clientY - r.top;
    hover = false;
    var newCursor='default';
    //ctx.clearRect(0, 0, canvas.width, canvas.height);
    for (var i=0;i<items_top.length;i++) {
        for (var j=0;j<items_top[i].items.length;j++) {
             if (items_top[i].items[j].type=='inverter') {
                idx = items_top[i].items[j].index;
                item=items_top[i];
                if(x >= item.items[j].x && x <= item.items[j].x + item.items[j].w &&
                   y >= item.items[j].y && y <= item.items[j].y + item.items[j].h) {
                    // The mouse honestly hits the rect
                    hover = true;
                    id = i;
                    newCursor='pointer';
                    //console.log("Mouseover!");


/*get the coordinates of the button element using jquery offset*/
/*get the top Position of the info element. $(window).scrollTop() is used to calculate the right top coordinate of the button element after the window is scrolled*/
var offset = $("#ezcanvas").offset();	
var topOffset = $("#ezcanvas").offset().top- $(window).scrollTop();
    $("#canvastitle").html("<table class='table table-striped'><tr><td>Rating</td><td>"+item.items[j].rating+"kW</td></tr><tr><td>Power Limit</td><td>"+item.items[j].pc+"% of rated</td></tr><tr><td>Active Generation</td><td>"+item.items[j].pc_now+"%</td></tr><tr><td>Potential</td><td>"+item.items[j].pc_potential+"%</td></tr></table>");
  /*set the position of the info element*/
	 $("#canvastitle").css({
        position: "fixed",
        top: (topOffset + item.items[j].y + item.items[j].h)+ "px",
        left: (offset.left+item.items[j].x) + "px",
        
    });


                    break;
                }
             }
        }
    }
    if (newCursor=='default') {
  /*hide info element on mouseout*/
             $('#canvastitle').css({'left':-9999});

    }
    canvas.style.cursor=newCursor;
}

$scope.$watch('livedata', function(liveData) {        
    if (liveData) {
        $scope.data=liveData;
        var canvas = document.getElementById('ezcanvas');
        myctx = canvas.getContext('2d');
        myctx.save();
        myctx.font = '12px sans-serif';
        lineHeight=myctx.measureText('M').width+2;
        //alert(lineHeight);
        //var text_title = $scope.data.ez1;
        //myctx.fillText(text_title, 15, canvas.height / 2 + 35);
        
        if (hasIrradiation) {
            myctx.fillStyle=background_color;
            myctx.textBaseline = 'top';
            myctx.fillRect(canvasWidth-gridWidth,gridHeight*0.6,gridWidth,gridHeight*0.3);
            myctx.fillStyle=text_color;
            //myctx.font = FONT_SIZE+'px sans-serif';
            myctx.font = '14px sans-serif';
            left_offset=(gridWidth*0.5 - myctx.measureText($scope.data.ez.solar_irradiation.toFixed(0) + " W").width)/2;
            console.log("left_offset="+left_offset+" grid_width="+gridWidth);
            //left_clear=gridWidth/2-myctx.measureText("-8888. WW").width/2;
            if ($scope.data.ez.sim)
                myctx.fillText($scope.data.ez.sim_irradiation.toFixed(0)+" W", canvasWidth-gridWidth+left_offset,gridHeight*0.6,gridWidth,gridHeight*0.3);
            else {
                myctx.fillText($scope.data.ez.solar_irradiation.toFixed(0)+" W", canvasWidth-gridWidth+left_offset,gridHeight*0.6,gridWidth,gridHeight*0.3);
                if ($scope.data.ez.potential_active>0) 
                    myctx.fillText($scope.data.ez.potential_active.toFixed(1)+" kW", canvasWidth-gridWidth+left_offset,gridHeight*0.72,gridWidth,gridHeight*0.3);
            }
            
        }
        
        if (hasWindSpeed) {
            myctx.fillStyle=background_color;
            myctx.textBaseline = 'top';
            myctx.fillRect(canvasWidth-gridWidth*2,gridHeight*0.6,gridWidth,gridHeight*0.3);
            myctx.fillStyle=text_color;
            //myctx.font = FONT_SIZE+'px sans-serif';
            myctx.font = '14px sans-serif';
            left_offset=(gridWidth*0.56 - myctx.measureText($scope.data.ez.wind_speed.toFixed(1) + " m/s").width)/2;

            myctx.fillText($scope.data.ez.wind_speed.toFixed(1)+" m/s", canvasWidth-gridWidth*2+left_offset,gridHeight*0.6,gridWidth,gridHeight*0.3);
            
        }

        imgs2 = [];
        // check inverters
        for (i=0;i<items_top.length;i++) {
            for (j=0;j<items_top[i].items.length;j++) {
                if (items_top[i].items[j].type=='meter') {
                    item=items_top[i];
                    idx = items_top[i].items[j].index;
                    if ($scope.data.ez.pm[idx].status==1) {
                        meter_st=urlPrefix+'/img/energymeter.png';
                    } else meter_st=urlPrefix+'/img/energymeter_off.png';
                    
                    //console.log("Inverter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+idx+" power="+$scope.data.ez.inv[items_top[i].items[j].index].power);
                    
                    myctx.fillStyle=background_color;
                    myctx.textBaseline = 'top';

                    if (items_top[i].items[j].image!=meter_st) {
                        items_top[i].items[j].image=meter_st;
                        imgs2.push({ uri: item.items[j].image, x: item.items[j].x, y:  item.items[j].y, sw: item.items[j].w, sh: item.items[j].h });
                    }
                    myctx.font = '12px sans-serif';

                    myctx.fillRect(items_top[i].items[j].x, items_top[i].items[j].y-items_top[i].items[j].h*0.2, items_top[i].items[j].w*0.4, items_top[i].items[j].h*0.2);
                    //myctx.fillStyle="#CCC";
                    myctx.fillRect(items_top[i].items[j].x+items_top[i].items[j].w*0.6, items_top[i].items[j].y+items_top[i].items[j].h, lineWidth+20, lineHeight+8);
                    myctx.fillStyle=text_color;
                    
                    myctx.fillText($scope.data.ez.pm[idx].id, items_top[i].items[j].x, items_top[i].items[j].y-items_top[i].items[j].h*0.2 );
                    myctx.font = FONT_SIZE+'px sans-serif';
                    myctx.font = '14px sans-serif';
                    myctx.fillStyle=text_color;
                    pwr=$scope.data.ez.pm[idx].power/1000;
                    
                    if ($scope.data.ez.pm[idx].status)
                        myctx.fillText(pwr.toFixed(1)+" kW", items_top[i].items[j].x+items_top[i].items[j].w*0.6, items_top[i].items[j].y+ items_top[i].items[j].h*1.05);

                    //console.log("Meter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+items_top[i].items[j].index);
                }
                if (items_top[i].items[j].type=='inverter') {
                    idx = items_top[i].items[j].index;
                    
                    if ($scope.data.ez.inv[idx].status==1) {
                        meter_st=urlPrefix+'/img/inverter.png';
                    } else meter_st=urlPrefix+'/img/inverter_off.png';
                    
                    item=items_top[i];
                    if (items_top[i].items[j].image!=meter_st) {
//                        console.log("top meter "+j+" changing meter to "+meter_st);
                        items_top[i].items[j].image=meter_st;


                        imgs2.push({ uri: item.items[j].image, x: item.items[j].x, y:  item.items[j].y, sw: item.items[j].w, sh: item.items[j].h });
                    }
                    //console.log("Inverter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+idx+" power="+$scope.data.ez.inv[items_top[i].items[j].index].power);
                    if ($scope.data.ez.inv[idx].has_pc==1) {
                    
                        progressBar(myctx,items_top[i].items[j].x+items_top[i].items[j].w*1.2, items_top[i].items[j].y+items_top[i].items[j].h*0.3,items_top[i].items[j].w*0.4,$scope.data.ez.inv[idx].pc,$scope.data.ez.inv[idx].pc_now,$scope.data.ez.inv[idx].pc_potential);
                        items_top[i].items[j].pc=$scope.data.ez.inv[idx].pc;
                        items_top[i].items[j].pc_now=$scope.data.ez.inv[idx].pc_now;
                        items_top[i].items[j].rating=$scope.data.ez.inv[idx].rating;
                        items_top[i].items[j].pc_potential=$scope.data.ez.inv[idx].pc_potential;
                        //console.log("Inverter at "+(items_top[i].items[j].x+items_top[i].items[j].w*1.2)+","+items_top[i].items[j].y+items_top[i].items[j].h*0.3+" and pc "+$scope.data.ez.inv[idx].pc);
                    }
                    myctx.font = '12px sans-serif';
                    myctx.fillStyle=background_color;
                    myctx.textBaseline = 'top';
                    myctx.textAlign='left';
                    myctx.fillRect(items_top[i].items[j].x, items_top[i].items[j].y-items_top[i].items[j].h*0.2, items_top[i].items[j].w*0.4, items_top[i].items[j].h*0.2);
                    //myctx.fillStyle="#CCC"
                    // clear the old inverter power
                    
                    //myctx.fillStyle="#eee";
                    myctx.fillRect(items_top[i].items[j].x+items_top[i].items[j].w*0.6, items_top[i].items[j].y+items_top[i].items[j].h, lineWidth, lineHeight+4);
                    
                    myctx.fillStyle=text_color;
                    myctx.fillText($scope.data.ez.inv[idx].id, items_top[i].items[j].x, items_top[i].items[j].y-items_top[i].items[j].h*0.18 );
                    
                    myctx.font = FONT_SIZE+'px sans-serif';
                    myctx.font = '14px sans-serif';
                    myctx.fillStyle=text_color;
                    pwr=$scope.data.ez.inv[idx].power/1000;
                    if ($scope.data.ez.inv[idx].status)
                        myctx.fillText(pwr.toFixed(1)+" kW", items_top[i].items[j].x+items_top[i].items[j].w*0.65, items_top[i].items[j].y+ items_top[i].items[j].h);
                }
            
            }
        }
        for (i=0;i<items_bottom.length;i++) {
            for (j=0;j<items_bottom[i].items.length;j++) {
                if (items_bottom[i].items[j].type=='meter') {
                    item=items_bottom[i];
                    idx = items_bottom[i].items[j].index;
                    //console.log("Inverter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+idx+" power="+$scope.data.ez.inv[items_top[i].items[j].index].power);
                    if ($scope.data.ez.pm[idx].status==1) {
                        meter_st=urlPrefix+'/img/energymeter.png';
                    } else meter_st=urlPrefix+'/img/energymeter_off.png';
                    
                    if (items_bottom[i].items[j].image!=meter_st) {
//                        console.log("top meter "+j+" changing meter to "+meter_st);
                        items_bottom[i].items[j].image=meter_st;
                        imgs2.push({ uri: item.items[j].image, x: item.items[j].x, y:  item.items[j].y, sw: item.items[j].w, sh: item.items[j].h });
                    }
                   myctx.font = '12px sans-serif';   
                    myctx.fillStyle=background_color;
                    myctx.textBaseline = 'top';

                    myctx.fillRect(items_bottom[i].items[j].x, items_bottom[i].items[j].y-items_bottom[i].items[j].h*0.2, items_bottom[i].items[j].w*0.4, items_bottom[i].items[j].h*0.2);
                    myctx.fillRect(items_bottom[i].items[j].x+items_bottom[i].items[j].w*0.6, items_bottom[i].items[j].y+items_bottom[i].items[j].h*1.05, items_bottom[i].items[j].w*1.5, items_bottom[i].items[j].h*0.2);
                    myctx.fillStyle=text_color;
                    myctx.fillText($scope.data.ez.pm[idx].id, items_bottom[i].items[j].x, items_bottom[i].items[j].y-items_bottom[i].items[j].h*0.2 );
                    pwr=$scope.data.ez.pm[idx].power/1000;
                    myctx.font = '14px sans-serif';
                    if ($scope.data.ez.pm[idx].status) {
                        if ($scope.data.ez.pm[idx].min || $scope.data.ez.pm[idx].max) {
                            if ((pwr<$scope.data.ez.pm[idx].min) || (pwr>$scope.data.ez.pm[idx].max)) {
                                myctx.fillStyle="red";
                            }
                        }
                        myctx.fillText(pwr.toFixed(1)+"kW", item.items[j].x+item.items[j].w*0.6, item.items[j].y+ item.items[j].h*1.05);
                    }
                }
            }
        }
        
        for (i=0;i<items_left.length;i++) {
            for (j=0;j<items_left[i].items.length;j++) {
                if (items_left[i].items[j].type=='meter') {
                    item=items_left[i];
                    idx = items_left[i].items[j].index;
                    //console.log("Inverter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+idx+" power="+$scope.data.ez.inv[items_top[i].items[j].index].power);
                    if ($scope.data.ez.pm[idx].status==1) {
                        meter_st=urlPrefix+'/img/energymeter.png';
                    } else meter_st=urlPrefix+'/img/energymeter_off.png';
                    
                    if (items_left[i].items[j].image!=meter_st) {
//                        console.log("top meter "+j+" changing meter to "+meter_st);
                        items_left[i].items[j].image=meter_st;
                        imgs2.push({ uri: item.items[j].image, x: item.items[j].x, y:  item.items[j].y, sw: item.items[j].w, sh: item.items[j].h });
                    }
                      myctx.font = '12px sans-serif';
                    myctx.fillStyle=background_color;
                    myctx.textBaseline = 'top';
                    left_offset=0;
                    pwr=$scope.data.ez.pm[idx].power/1000;
                    
                    if (item.bottom) {
                        left_offset = item.items[j].w*0.6
                        left_clear=item.items[j].w*0.6;
                    } else {
                        left_offset=item.items[j].w/2-myctx.measureText(pwr.toFixed(1)+" kW").width/2;
                        left_clear=item.items[j].w/2-myctx.measureText("-8888.8 kW").width/2;
                    }
                    console.log("Left Offset="+left_offset);
                   //myctx.fillStyle="#CCC";
                    //myctx.fillRect(item.items[j].x, item.items[j].y-item.items[j].h*0.2, item.items[j].w*0.4, item.items[j].h*0.2);
                    reactive_pwr=$scope.data.ez.pm[idx].reactive_power/1000;
                    
                    myctx.fillRect(item.items[j].x-lineWidth/2, item.items[j].y+item.items[j].h, lineWidth+25, lineHeight+15);
                    myctx.fillRect(item.items[j].x-item.items[j].w*0.22, item.items[j].y+item.items[j].h*0.1, item.items[j].w*0.21, item.items[j].h*0.25);
                    myctx.fillRect(item.items[j].x+item.items[j].w, item.items[j].y+item.items[j].h*0.1, item.items[j].w*0.22, item.items[j].h*0.25);
                    
                    myctx.fillStyle=background_color;
                    myctx.fillRect(item.items[j].x, item.items[j].y-item.items[j].h*0.2, item.items[j].w*0.4, item.items[j].h*0.2);
                    //myctx.fillStyle="#ccc";
                    myctx.fillRect(item.items[j].x+left_clear, item.items[j].y+item.items[j].h*1.05, item.items[j].w*1.5, item.items[j].h*0.4);
                    myctx.fillStyle=text_color;
                    myctx.fillText($scope.data.ez.pm[idx].id, item.items[j].x, item.items[j].y-item.items[j].h*0.2 );
                    
                    pwr=$scope.data.ez.pm[idx].power/1000;
                    
                    myctx.font = '14px sans-serif';
                    if ($scope.data.ez.pm[idx].status) {
                        if ($scope.data.ez.pm[idx].min || $scope.data.ez.pm[idx].max) {
                            if ((pwr<$scope.data.ez.pm[idx].min) || (pwr>$scope.data.ez.pm[idx].max)) {
                                myctx.fillStyle="red";
                            }
                        }
                        myctx.fillText(pwr.toFixed(1)+" kW", item.items[j].x+left_offset, item.items[j].y+ item.items[j].h*1.06);
                        if (reactive_pwr!=0) {
                             myctx.fillText(reactive_pwr.toFixed(1)+" kVAr", item.items[j].x+left_offset, item.items[j].y+ item.items[j].h*1.25);
                        }
                    }
                    
                    if (pwr>0) {
                        myctx.fillStyle="#70c041";
                        drawArrowhead(myctx, {x:item.items[j].x,y:item.items[j].y+item.items[j].h*0.2}, {x:item.items[j].x+item.items[j].w*1.1,y:item.items[j].y+item.items[j].h*0.2}, item.items[j].w/8);
                    } else if (pwr<0) {
                        myctx.fillStyle="#c93838";
                        drawArrowhead(myctx, {x:item.items[j].x+item.items[j].w,y:item.items[j].y+item.items[j].h*0.2}, {x:item.items[j].x-item.items[j].w*0.1,y:item.items[j].y+item.items[j].h*0.2},item.items[j].w/8);
                    }

                    //console.log("Meter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+items_top[i].items[j].index);
                }
            }
        }
        
        for (i=0;i<items_right.length;i++) {
            for (j=0;j<items_right[i].items.length;j++) {
                if (items_right[i].items[j].type=='meter') {
                    item=items_right[i];
                    idx = items_right[i].items[j].index;
                    //console.log("Inverter at "+items_top[i].items[j].x+","+items_top[i].items[j].y+" and index "+idx+" power="+$scope.data.ez.inv[items_top[i].items[j].index].power);
                    if ($scope.data.ez.pm[idx].status==1) {
                        meter_st=urlPrefix+'/img/energymeter.png';
                    } else meter_st=urlPrefix+'/img/energymeter_off.png';
                    myctx.font = '12px sans-serif';
                    if (items_right[i].items[j].image!=meter_st) {
//                        console.log("top meter "+j+" changing meter to "+meter_st);
                        items_right[i].items[j].image=meter_st;
                        imgs2.push({ uri: item.items[j].image, x: item.items[j].x, y:  item.items[j].y, sw: item.items[j].w, sh: item.items[j].h });
                    }
                      
                    myctx.fillStyle=background_color;
                    myctx.textBaseline = 'top';
                    left_offset=0;
                    pwr=$scope.data.ez.pm[idx].power/1000;
                    
                    if (item.bottom) {
                        left_offset = item.items[j].w*0.6
                        left_clear=item.items[j].w*0.6;
                    } else {
                        left_offset=item.items[j].w/2-myctx.measureText(pwr.toFixed(1)+"kW").width/2;
                        left_clear=item.items[j].w/2-myctx.measureText("-8888.8kW").width/2;
                    }
//                    myctx.fillRect(item.items[j].x-item.items[j].w*0.22, item.items[j].y+item.items[j].h*0.1, item.items[j].w*0.21, item.items[j].h*0.25);
                    //myctx.fillRect(item.items[j].x+item.items[j].w, item.items[j].y+item.items[j].h*0.1, item.items[j].w*0.22, item.items[j].h*0.25);
                    myctx.fillRect(item.items[j].x, item.items[j].y-item.items[j].h*0.2, item.items[j].w*0.4, item.items[j].h*0.2);
                    
                    myctx.fillRect(item.items[j].x-lineWidth/2, item.items[j].y+item.items[j].h, lineWidth+25, lineHeight+15);
                    
                    myctx.fillStyle=background_color;
                    myctx.fillRect(item.items[j].x, item.items[j].y-item.items[j].h*0.2, item.items[j].w*0.4, item.items[j].h*0.2);
                    myctx.fillRect(item.items[j].x+left_clear, item.items[j].y+item.items[j].h*1.05, item.items[j].w*1.1, item.items[j].h*0.2);
                    myctx.fillStyle=text_color;
                    myctx.fillText($scope.data.ez.pm[idx].id, item.items[j].x, item.items[j].y-item.items[j].h*0.2 );
                    myctx.font = '14px sans-serif';
                    if ($scope.data.ez.pm[idx].status)
                        myctx.fillText(pwr.toFixed(1)+"kW", item.items[j].x+left_offset, item.items[j].y+ item.items[j].h*1.06);
                }
            }
        }
        
        if ($scope.data.ez.sim) {
            myctx.fillStyle="#eee";//background_color;
            myctx.textBaseline = 'top';
            
            myctx.fillRect(canvasWidth*0.67,canvasHeight-canvasHeight*0.12,canvasWidth*0.3,canvasHeight*0.12);
            //myctx.font = '16px Roboto, Helvetica, Arial';
            myctx.font = '15px sans-serif';
            myctx.fillStyle=text_color;
            sim_text="Export"
            if ($scope.data.ez.sim_mode==1) {
                sim_text="Zero Export";
            } else if ($scope.data.ez.sim_mode==2) {
                sim_text="DG Protection";
            }
            ftop=canvasHeight-canvasHeight*0.1;
            //console.log("Sim Text "+sim_text+" "+canvasWidth*0.7+" "+ftop);
            myctx.fillText("Sim Mode:"+sim_text,canvasWidth*0.7,ftop);
            ftop+= myctx.measureText('M').width*1.5;
            //myctx.font = '14px Roboto, Helvetica, Arial';
            myctx.font = '13px sans-serif';
            myctx.fillText("Irradiation: "+$scope.data.ez.sim_irradiation+" W",canvasWidth*0.7,ftop);
            ftop+= myctx.measureText('M').width*1.5;
            myctx.font = '13px sans-serif';
            //myctx.font = '14px Roboto, Helvetica, Arial';
            myctx.fillText("Inverters: "+$scope.data.ez.inv[0].rating+" kW",canvasWidth*0.7,ftop);
             
        }
        
        myctx.restore();
        imgs2.forEach(depict);
    }
});

// sim mode changed

$scope.$watch('sim_mode', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_mode&val="+$scope.sim_mode)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_irradiation', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_irradiation&val="+$scope.sim_irradiation)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_dg10', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_dg10&val="+$scope.sim_dg10)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_dg11', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_dg11&val="+$scope.sim_dg11)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_dg12', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_dg12&val="+$scope.sim_dg12)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});

$scope.$watch('sim_dg13', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_dg13&val="+$scope.sim_dg13)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_dg14', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_dg14&val="+$scope.sim_dg14)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
$scope.$watch('sim_load', function(liveData) {
    //alert('sim mdoe set to '+$scope.sim_mode);
    if ($scope.data.ez.sim)
    if (liveData!=undefined)
        $http.get("/app/mbsetvar.cgi?globalvar=sim_load&val="+$scope.sim_load*1000)
                .then(function (response) {
                    var sdata = response.data;      
                }, 
                function(reason) {
                    $scope.errormsg="";
                    $scope.successmsg="";
            
           
                });
});
}





