var code_functions=new Array(
    {name:'adc_read',params:'channel',desc:'read onboard ADC channel'},
{name:'array_key',params:'array,index',desc:'returns key name of array element at index'},
{name:'array_keys',params:'array',desc:'return keys for an array'},
{name:'base64_decode',params:'string',desc:'returns base64-decoded version of string'},
{name:'base64_encode',params:'string',desc:'returns base64-encoded version of string'},
{name:'call_user_func',params:'string function_name, optional parameters',desc:'calls a user defined function with optional parameters'},
{name:'charat',params:'string,index',desc:'return ASCII code for character in string at index'},
{name:'chdir',params:'string',desc:'Returns 0 if successful'},
{name:'chr',params:'number',desc:'return character for number'},
{name:'cos',params:'number or float',desc:'return cosine of number'},
{name:'current',params:'array',desc:'returns the current element in the array'},
{name:'debug',params:'string',desc:'print to debug output'},
{name:'debugout',params:'number',desc:'Enabled (1) or disable (0) output to the standard output'},
{name:'die',params:'none',desc:'kill script'},
{name:'disk_free_space',params:'int [volume]',desc:'get free space on SD'},
{name:'disk_total_space',params:'int [volume]',desc:'get total space on SD'},
{name:'error_reporting',params:'int verbosity',desc:'0=error,1=warning,2=notice'},
{name:'exec',params:'string filename, number msinterval',desc:'run a script'},
{name:'exec_action',params:'string act_name or int act_id',desc:'triggers a manually triggerable actions by ID. Returns 1 if successful, 0 for error'},
{name:'explode',params:'string value,string delimiter',desc:'turn a string into an array'},
{name:'fclose',params:'number handle',desc:'Closes a file, stream or socket with the passed handle'},
{name:'feof',params:'number handle',desc:'Returns 0 if no more data is available, or 1 if there is data'},
{name:'fgets',params:'number handle, optional number bytes',desc:'returns a single line from the file or stream, optionally upto the number of bytes specified'},
{name:'file_exists',params:'string filename',desc:'Returns 1 if the file exists'},
{name:'filesize',params:'number handle',desc:'for files returns the number of bytes in file, for stream returns the number of bytes pending'},
{name:'findfirst',params:'string pattern, number flags',desc:'Start searching the current folder for files matching the pattern and with specified flags. Returns an array with the first matching info'},
{name:'findnext',params:'',desc:'Return next matching file information as array'},
{name:'firmwareupdate',params:'',desc:'initiates a firmware update sequence and reboots the device'},
{name:'floatval',params:'Mixed value',desc:'returns the floating point value of the number or string'},
{name:'flush',params:'',desc:'Flushes current output to the browser'},
{name:'f485open',params:'int baudrate, int parity',desc:'Opens RS-485 port for operation and returns file handle – make sure modbus is disabled'},
{name:'fopen',params:'string filename, string status',desc:'Opens a file for reading or writing, returns the handle for future operations'},
{name:'fread',params:'number handle, number bytes',desc:'returns number bytes from the stream'},
{name:'freemem',params:'',desc:'Returns bytes free'},
{name:'freestack',params:'none',desc:'Returns words free on currents stack'},
{name:'fseek',params:'number handle, number position, number position_type',desc:'Locate file pointer inside the open file to position.  If position_type is 0, it seeks from the start.  If position_type is 1, it seeks from the current position.  If position_type=2 it seeks from the end'},
{name:'fseropen',params:'number baudrate, optional number blocking, optional invert, optional parity',desc:'Opens the serial port at the specified baud rate'},
{name:'fsockopen',params:'string host, optional number timeout',desc:'Attempts to create a socket to the host with the protocol specified and returns a handle or 0 if failed'},
{name:'ftell',params:'int handle',desc:'Returns file position of open file handle'},
{name:'function_exists',params:'string funcname',desc:'Checks if a function (custom or native) exists and returns 1 if so'},
{name:'fwrite',params:'number handle, mixed value',desc:'writes data to the stream or file'},
{name:'get3gstat',params:'',desc:'Returns an array of the status of the USB Dongle network interface'},
{name:'getcwd',params:'',desc:'Gets the current directory'},
{name:'getethstat',params:'',desc:'Returns an array of the status of the LAN interface'},
{name:'getmbstat',params:'none',desc:'Returns array of modbus statistics'},
{name:'getmac',params:'',desc:'Returns the network MAC address'},
{name:'getusbstat',params:'',desc:'Returns information about the USB host status'},
{name:'header',params:'string',desc:'add to http header'},
{name:'htmlspecialchars',params:'string',desc:'convert characters for display in html'},
{name:'ieee754toint',params:'float',desc:'int representation of a float'},
{name:'implode',params:'array, string separator',desc:'Implodes the array with the separator and returns a string'},
{name:'include',params:'string filename',desc:'includes a file at the current location'},
{name:'indexed_array',params:'int type, int size',desc:'Creates an indexed array of the specified type'},
{name:'ini_get',params:'string ini, string section, string key, mixed defvalue',desc:'returns the value associated with the key if it exists, or the default value otherwise'},
{name:'ini_get_array',params:'string ini, string section',desc:'returns a key/value array of all items in the section'},
{name:'ini_put_array',params:'string ini, optional string section',desc:'writes the values in the key/value array to the ini file or to the section inside, if specified.'},
{name:'ini_set',params:'string ini, string section, string key, mixed value',desc:'writes the value to the section in an INI file'},
{name:'inttoieee754',params:'number',desc:'floating point value of 4-byte IEEE number'},
{name:'intval',params:'string or float',desc:'integer value of the parameter'},
{name:'is_array',params:'mixed value',desc:'Returns 1 if the variable or value is an array'},
{name:'is_float',params:'mixed value',desc:'Returns 1 if the variable or value is a floating point value'},
{name:'is_int',params:'mixed value',desc:'Returns 1 if the variable or value is an integer'},
{name:'is_numeric',params:'mixed value',desc:'Returns 1 if the value is numeric (integer or float)'},
{name:'is_string',params:'mixed value',desc:'Returns 1 if the variable or value is a string'},
{name:'isset',params:'variable',desc:'Returns 1 if the variable exists'},
{name:'json_encode',params:'array,type [0=object,1=array)',desc:'encode an array as a string'},
{name:'key',params:'array',desc:'Returns the key of the currently selected array index'},
{name:'ln',params:'number',desc:'return natural logarithm of number'},
{name:'log',params:'string, [string]',desc:'print to log, optional second parameter is path to custom log file'},
{name:'log10',params:'number',desc:'return log10 of number'},
{name:'mail',params:'string recipient, string title, string body',desc:'0=success, other number contains SMTP error code'},
{name:'max_execution_time',params:'number',desc:'set maximum execution time in seconds'},
{name:'mb_add_dev',params:'number device_id, number device_type_id, string name, number poll_interval, number status',desc:'adds a device to the list of polled devices'},
{name:'mb_delete_device',params:'number device_id',desc:'delete a device from the list of active device with the slave ID passed'},
{name:'mb_get_dev_by_id',params:'number id',desc:'modbus device details'},
{name:'mb_get_dev_by_index',params:'number index',desc:'modbus device details'},
{name:'mb_get_dev_by_name',params:'string name',desc:'modbus device details'},
{name:'mb_get_dev_info',params:'number device type id',desc:'modbus device details'},
{name:'mb_get_role_array',params:'',desc:'array of all roles and their values'},
{name:'mb_get_status_by_role',params:'number role_id',desc:'status of the device attached to the role'},
{name:'mb_get_val_by_role',params:'number role_id',desc:'value of the role in the system'},
{name:'mb_num_devices',params:'',desc:'number of devices on the modbus'},
{name:'mb_queue_command',params:'mixed, multiple parameters',desc:'send a sequence of characters to the rs485 bus but dont wait for a reply'},
{name:'mb_scan_complete',params:'',desc:'1=complete, 0=ongoing'},
{name:'mb_scan_percent',params:'',desc:'percentage completed of scan'},
{name:'mb_send_command',params:'mixed, multiple parameters',desc:'send a sequence of characters to the rs485 bus and get reply'},
{name:'mb_set_dev_var',params:'string or number device name or id, param string, value',desc:'set a variable on a modbus device'},
{name:'mb_set_val_by_role',params:'number role_id, number value',desc:'set a role value on a modbus device'},
{name:'mb_start_scan',params:'number start, number end',desc:'initiates an automatic scan of modbus bus'},
{name:'md5',params:'string',desc:'Returns 32 character hash of the string'},
{name:'md5_file',params:'string filename',desc:'returns the MD5 hash of a file'},
{name:'microtime',params:'',desc:'number of milliseconds since boot'},
{name:'mkdir',params:'string',desc:'FR_OK or erro code'},
{name:'mktime',params:'number hr,min,sec,month,day,year',desc:'linux timestamp of date'},
{name:'net_disable3g',params:'',desc:'Disable usb dongle net connectivity '},
{name:'net_enable3g',params:'',desc:'Enabled usb dongle net connectivity if available'},
{name:'netstat',params:'',desc:'returns information about the current http connections'},
{name:'next',params:'array',desc:'returns the next element in the array'},
{name:'number_format',params:'mixed num, number digits',desc:'formats the number with the specified number of digits of precision'},
{name:'nvram_backup',params:'string filename',desc:'writes contents of nvram to the file in filename'},
{name:'nvram_defrag',params:'',desc:'defragments nvram if required'},
{name:'nvram_dump',params:'',desc:'dumps the contents of nvram to the standard output'},
{name:'nvram_free',params:'',desc:'number of free bytes in nvram'},
{name:'nvram_get',params:'string key, mixed def_value',desc:'returns the value of the key in nvram, or the def_value if not yet assigned'},
{name:'nvram_restore',params:'string filename',desc:'reads contents of filename into nvram'},
{name:'nvram_set',params:'string key, string value',desc:'sets a key and value in nvram'},
{name:'nvram_unset',params:'string key',desc:'clears a key from nvram'},
{name:'ord',params:'string char',desc:'Returns the ASCII number of the character'},
{name:'ow_first',params:'',desc:'Initiates a onewire scan and returns the first device found'},
{name:'ow_next',params:'',desc:'Returns the next device found or 0 if none'},
{name:'ow_read',params:'',desc:'Reads a byte from the onewire bus'},
{name:'ow_read_temp',params:'optional array',desc:'Returns the temperature in degrees celcius for the device'},
{name:'ow_reset',params:'',desc:'Resets the onewire bus'},
{name:'ow_write',params:'number val',desc:'Writes a byte to the onewire bus'},
{name:'phpinfo',params:'',desc:'returns information about the system'},
{name:'pin_configure',params:'number pin, number pin_type, [cntype]',desc:'configures an IO pin as a digital input, output, or analog input types: 1=OUTPUT, 2 = INPUT, 4=ANALOG,16=COUNTER'},
{name:'pin_get',params:'number pin, [pin type],[pin info]',desc:'get the value of digital input pin.  For WMPRO, pin_type is 0=output, 1=input, and pin_info=0=cur value, 1=total pulses, 2=interval'},
{name:'pin_set',params:'Number pin_number, number value',desc:'sets a digital output to value (1 or 0)'},
{name:'ping',params:'string host',desc:'sends an ICMP ping and puts the result in the array'},
{name:'power',params:'number num, number factor',desc:'returns num to the power of factor'},
{name:'prev',params:'array',desc:'returns value of previous array element and updates index'},
{name:'print',params:'mixed',desc:'output data to the current output stream such as web page or terminal'},
{name:'print_r',params:'array',desc:'dump the contents of an array to the current output'},
{name:'printf',params:'string format, optional values',desc:'prints a formatted string to the standard output'},
{name:'process_kill',params:'number process_id',desc:'sends a kill request to the process number'},
{name:'process_list',params:'',desc:'returns an array of the currently running scripts'},
{name:'rand',params:'int min, int max',desc:'returns random number between min and max'},
{name:'reboot',params:'',desc:'reset the processor'},
{name:'rename',params:'string source, stirng dest',desc:'Renames or moves a file from source to dest name'},
{name:'reset',params:'',desc:'Resets the processor'},
{name:'rmdir',params:'string dir',desc:'Removes a directory, returns 0 if successful'},
{name:'session_destroy',params:'',desc:'clears the current sessions data'},
{name:'session_is_new',params:'',desc:'Returns 1 if the session is just initiated'},
{name:'session_start',params:'',desc:'initiates a new session and sends the cookie data for it'},
{name:'set_search_path',params:'string',desc:'sets the search path for the telnet client'},
{name:'setethpower',params:'number',desc:'Enables or disables the ethernet controller'},
{name:'setpriority',params:'number',desc:'sets the priority of the script (2 is high, 1 is low)'},
{name:'settime',params:'number, [calib]',desc:'Set system from linux timestamp – optional Calibration Register'},
{name:'setusbpower',params:'number',desc:'sets the USB host power on or off (1 or 0)'},
{name:'sha1',params:'string',desc:'returns the 40-character hash of the string'},
{name:'sin',params:'number',desc:'Returns the sin value of the number'},
{name:'sizeof',params:'array ',desc:'returns the number of elements in an array'},
{name:'sleep',params:'number',desc:'Sleep for specified milliseconds'},
{name:'spi_clearcs',params:'',desc:'clears the CS output of the SPI bus'},
{name:'spi_read',params:'',desc:'reads a byte from the SPI bus'},
{name:'spi_setcs',params:'',desc:'sets the CS output of the SPI bus'},
{name:'spi_write',params:'number',desc:'writes a byte to the SPI bus'},
{name:'sprintf',params:'string format, optional values',desc:'formats a string using the format specified using the passed parameters and returns a string'},
{name:'sqr',params:'number',desc:'Returns the square of a number'},
{name:'sqrt',params:'number',desc:'Returns the square root of a number'},
{name:'stats',params:'',desc:'Returns system statistics'},
{name:'strftime',params:'string format, number time',desc:'formats the passed time using the format string'},
{name:'strlen',params:'string str',desc:'Returns the length of a string'},
{name:'strpos',params:'string haystack, string needle',desc:'Returns the position of the first occurence of needle in haystack or -1 if not found'},
{name:'strrpos',params:'string haystack, string needle',desc:'Returns the last occurence of haystack in needle, or -1 if not found'},
{name:'strtolower',params:'string',desc:'returns the lowercase version of the string'},
{name:'strtoupper',params:'string',desc:'returns the uppercase version of the string'},
{name:'strval',params:'Mixed value',desc:'Returns the string value of the passed parameter'},
{name:'substr',params:'string str, number start, number len',desc:'returns a substring of the passed string from start for len characters.  If len is blank it will return the string until the end'},
{name:'tar_finish',params:'number handle',desc:'adds the ending header to a TAR file'},
{name:'tar_put',params:'number handle, string filename',desc:'adds a file to the currently open file handle in TAR format'},
{name:'time',params:'',desc:'Returns the current system timestamp'},
{name:'timefromfat',params:'number',desc:'converts a FAT filetime to a native timestamp'},
{name:'trim',params:'string',desc:'returns trimmed version of the string (no white spaces)'},
{name:'ucfirst',params:'string',desc:'convert string to lowercase except for first character'},
{name:'unlink',params:'string filename',desc:'removes a file (deletes it)'},
{name:'untar',params:'string filename, number verbose',desc:'untars a file into the current folder, optionally verbose'},
{name:'uptime',params:'',desc:'uptime in milliseconds'},
{name:'usb_info',params:'',desc:'information about the USB device'},
{name:'get_rtc_calib',params:'none',desc:'returns the RTC calibration register'}
);